算法工程题1.4

复制代码
* 问题标题:找出字符串中第一个匹配项的下表
* 题意说明:
*   给你两个字符串 haystack 和 needle ,请你在 haystack 字符串中找出 needle 字符串的第一个匹配项的下标(下标从 0 开始)。
*   如果 needle 不是 haystack 的一部分,则返回 -1 。
*
*  示例 1:
*      输入:haystack = "sadbutsad", needle = "sad"
*      输出:0
*      解释:"sad" 在下标 0 和 6 处匹配。
*      第一个匹配项的下标是 0 ,所以返回 0 。
*
*  示例 2:
*      输入:haystack = "leetcode", needle = "leeto"
*      输出:-1
*      解释:"leeto" 没有在 "leetcode" 中出现,所以返回 -1 。
*
*  提示:
*      1 <= haystack.length, needle.length <= 104
*      haystack 和 needle 仅由小写英文字符组成
*
*  Related Topics
*      双指针
*      字符串
*      字符串匹配
java 复制代码
public class StrStr_0009 {

    public static void main(String[] args) {

    }
    public int strStr(String haystack, String needle) {
        return 0;
    }
}

使用双指针:

java 复制代码
package com.czxy;


/**
 * @ClassName StrStr_0009
 * @Author cheng
 * @Description 问题标题:找出字符串中第一个匹配项的下表
 * 题意说明:
 *   给你两个字符串 haystack 和 needle ,请你在 haystack 字符串中找出 needle 字符串的第一个匹配项的下标(下标从 0 开始)。
 *   如果 needle 不是 haystack 的一部分,则返回 -1 。
 *
 *  示例 1:
 *      输入:haystack = "sadbutsad", needle = "sad"
 *      输出:0
 *      解释:"sad" 在下标 0 和 6 处匹配。
 *      第一个匹配项的下标是 0 ,所以返回 0 。
 *
 *  示例 2:
 *      输入:haystack = "leetcode", needle = "leeto"
 *      输出:-1
 *      解释:"leeto" 没有在 "leetcode" 中出现,所以返回 -1 。
 *
 *  提示:
 *      1 <= haystack.length, needle.length <= 104
 *      haystack 和 needle 仅由小写英文字符组成
 *
 *  Related Topics
 *      双指针
 *      字符串
 *      字符串匹配
 *
 * @Date 2023/8/4 9:53
 * @Version 1.0
 */
public class StrStr_0009 {

    public static void main(String[] args) {
      String haystack = "sadbutsad";
      String needle="sad";
      System.out.println(strStr(haystack,needle));
    }
    public static int strStr(String haystack, String needle) {
      // 用来记录满足条件的下标
      int ind = -1;
      // 记录相等字符串长度
      int count = 0;
      // 判断是否包含该字符串
      if(haystack.contains(needle)) {
        for (int i = 0; i < haystack.length(); i++) {
          for (int j = 0; j < needle.length(); j++) {
            // 从第一个字符串的位置开始判断之后每个字符是否相等,相等则记录相等数量 count 并且结束当前循环
            if (i + j < haystack.length() && haystack.charAt(i + j) == needle.charAt(j)) {
              count++;
              continue;
            }
          }
          // 判断count 是否与要比较的字符串长度相等
          if (count == needle.length()) {
            // 相等则记录该字符第一个位置下标
            ind = i;
            // 结束程序
            break;
          } else {
            // 没有找到匹配字符串
            ind = -1;
            // 重置count
            count = 0;
          }
        }
      }
    return  ind;
    }
}
相关推荐
写后端的胖头鱼1 小时前
一文详解B+树原理(附场景+示例)
数据结构·b树
怕浪猫2 小时前
RAG 面试 6 连问,从原理到优化全部覆盖
python·算法·面试
无线通信科研笔记3 小时前
IEEE TVT 2026 论文精读与完整复现|相位误差如何重塑近场 RIS 的幅相响应
论文阅读·人工智能·python·算法·论文笔记
mmmmath_34 小时前
二叉树の递归遍历
算法
All for pursuit.4 小时前
【位运算-1】338.比特位计数
数据结构·c++·算法·leetcode
小师兄吃牛肉5 小时前
C语言中的nullptr有必要吗
c语言·c++·算法
一只小小的芙厨6 小时前
【线性DP】
学习·算法·动态规划
xxwl5856 小时前
数据结构知识点和代码实现总结(C语言实现)
c语言·开发语言·数据结构
奋发向前wcx6 小时前
CSP-J复赛模拟赛5 王晨旭补题 2026.10.5
算法
罗湖老棍子8 小时前
C Looooops(信息学奥赛一本通- P1640)
算法·数论·同余·裴蜀定理·扩展欧几里得